import torch
from transformers import AutoTokenizer, OpenAIGPTLMHeadModel

def gpt_process(text):
    tokenizer = AutoTokenizer.from_pretrained("openai-gpt")
    model = OpenAIGPTLMHeadModel.from_pretrained("openai-gpt")

    inputs = tokenizer(text, return_tensors="pt")
    outputs = model(**inputs, labels=inputs["input_ids"])
    loss = outputs.loss
    logits = outputs.logits 
    return outputs
