from sklearn.ensemble import RandomForestClassifier
from sklearn.cluster import KMeans
import numpy as np
from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.feature_extraction.text import CountVectorizer
from joblib import dump, load

def vectorizing(X, Y):
        vectorizer = TfidfVectorizer()
        X = vectorizer_x.fit(X)
        Y = vectorizer_y.fit(Y)
        X = vectorizer_x.transform(X)
        Y = vectorizer_y.transform(Y)
        return X, Y, vectorizer_x, vectorizer_y
    
"""def vectorizing(X, Y):
        vectorizer = CountVectorizer()
        X = vectorizer_x.fit(X)
        Y = vectorizer_y.fit(Y)
        X = vectorizer_x.transform(X)
        Y = vectorizer_y.transform(Y)
        X = X.toarray()
        Y = Y.toarray()
        return X, Y, vectorizer_x, vectorizer_y"""

class request_classificate:
    def train(X_train, Y_train):
        X_train, Y_train, vectorizer_x, vectorizer_y = vectorizing(X_train, Y_train)
        clf = RandomForestClassifier(max_depth=len(Y_train), random_state=0)
        clf.fit(X_train, Y_train)
        dump(clf, 'user_request_classifier.joblib')
    def test(X_test):
        clf = load('user_request_classifier.joblib')
        X_test = vectorizer_x.transform(X_test)
        Y_pred = clf.predict(X_test)
        Y_pred = vectorizer_y.inverse_transform(Y_pred)
        return Y_pred
    
class request_categorizate:
    def train(X_train, Y_train):
        X_train, Y_train, vectorizer_x, vectorizer_y = vectorizing(X_train, Y_train)
        kmeans = KMeans(n_clusters=len(Y_train), random_state=0, n_init="auto")
        kmeans.fit(X_train, Y_train)
        dump(kmeans, 'user_request_categorizator.joblib')
    def test(X_test):
        kmeans = load('user_request_categorizator.joblib')
        X_test = vectorizer_x.transform(X_test)
        Y_pred = kmeans.predict(X_test)
        Y_pred = vectorizer_y.inverse_transform(Y_pred)
        return Y_pred
